//  -*- Mode: Java -*-
//
// _StartupGuiServerApi.java

/*
 +---------------------------- BEGIN LICENSE BLOCK ---------------------------+
 |                                                                            |
 | Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
 |                                                                            |
 | The contents of this file are subject to the Mozilla Public License        |
 | Version 1.1 (the "License"); you may not use this file except in           |
 | compliance with the License. You may obtain a copy of the License at       |
 | http://www.mozilla.org/MPL/                                                |
 |                                                                            |
 | Software distributed under the License is distributed on an "AS IS" basis, |
 | WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
 | for the specific language governing rights and limitations under the       |
 | License.                                                                   |
 |                                                                            |
 | The Original Code is the PowerLoom KR&R System.                            |
 |                                                                            |
 | The Initial Developer of the Original Code is                              |
 | UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
 | 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
 |                                                                            |
 | Portions created by the Initial Developer are Copyright (C) 2002-2014      |
 | the Initial Developer. All Rights Reserved.                                |
 |                                                                            |
 | Contributor(s):                                                            |
 |                                                                            |
 | Alternatively, the contents of this file may be used under the terms of    |
 | either the GNU General Public License Version 2 or later (the "GPL"), or   |
 | the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
 | in which case the provisions of the GPL or the LGPL are applicable instead |
 | of those above. If you wish to allow use of your version of this file only |
 | under the terms of either the GPL or the LGPL, and not to allow others to  |
 | use your version of this file under the terms of the MPL, indicate your    |
 | decision by deleting the provisions above and replace them with the notice |
 | and other provisions required by the GPL or the LGPL. If you do not delete |
 | the provisions above, a recipient may use your version of this file under  |
 | the terms of any one of the MPL, the GPL or the LGPL.                      |
 |                                                                            |
 +----------------------------- END LICENSE BLOCK ----------------------------+
*/

package edu.isi.powerloom.server.gui;

import edu.isi.stella.javalib.Native;
import edu.isi.stella.javalib.StellaSpecialVariable;
import edu.isi.stella.*;
import edu.isi.powerloom.logic.*;
import edu.isi.webtools.objects.xml_objects.*;
import edu.isi.webtools.soap.*;
import edu.isi.powerloom.server.*;

public class _StartupGuiServerApi {
  static void helpStartupGuiServerApi1() {
    {
      GuiServer.KWD_LOG_LEVELS = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("LOG-LEVELS", null, 2)));
      GuiServer.KWD_LEVEL = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("LEVEL", null, 2)));
      GuiServer.KWD_DEVELOPMENT = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("DEVELOPMENT", null, 2)));
      GuiServer.KWD_HIGH = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("HIGH", null, 2)));
      GuiServer.KWD_LOW = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("LOW", null, 2)));
      GuiServer.KWD_PREFIX = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("PREFIX", null, 2)));
      GuiServer.KWD_MAX_WIDTH = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("MAX-WIDTH", null, 2)));
      GuiServer.KWD_STREAM = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("STREAM", null, 2)));
      GuiServer.SGT_LOGIC_LOGIC_OBJECT = ((Surrogate)(GeneralizedSymbol.internRigidSymbolWrtModule("LOGIC-OBJECT", Stella.getStellaModule("/LOGIC", true), 1)));
      GuiServer.SGT_STELLA_CONS = ((Surrogate)(GeneralizedSymbol.internRigidSymbolWrtModule("CONS", Stella.getStellaModule("/STELLA", true), 1)));
      GuiServer.SGT_LOGIC_TRUTH_VALUE = ((Surrogate)(GeneralizedSymbol.internRigidSymbolWrtModule("TRUTH-VALUE", Stella.getStellaModule("/LOGIC", true), 1)));
      GuiServer.SGT_LOGIC_NAMED_DESCRIPTION = ((Surrogate)(GeneralizedSymbol.internRigidSymbolWrtModule("NAMED-DESCRIPTION", Stella.getStellaModule("/LOGIC", true), 1)));
      GuiServer.SGT_LOGIC_SKOLEM = ((Surrogate)(GeneralizedSymbol.internRigidSymbolWrtModule("SKOLEM", Stella.getStellaModule("/LOGIC", true), 1)));
      GuiServer.SYM_STELLA_CODE_ONLYp = ((Symbol)(GeneralizedSymbol.internRigidSymbolWrtModule("CODE-ONLY?", Stella.getStellaModule("/STELLA", true), 0)));
      GuiServer.SYM_STELLA_JAVA_FLOTSAM_CLASS = ((Symbol)(GeneralizedSymbol.internRigidSymbolWrtModule("JAVA-FLOTSAM-CLASS", Stella.getStellaModule("/STELLA", true), 0)));
      GuiServer.SYM_STELLA_APIp = ((Symbol)(GeneralizedSymbol.internRigidSymbolWrtModule("API?", Stella.getStellaModule("/STELLA", true), 0)));
      GuiServer.SGT_STELLA_LITERAL = ((Surrogate)(GeneralizedSymbol.internRigidSymbolWrtModule("LITERAL", Stella.getStellaModule("/STELLA", true), 1)));
      GuiServer.KWD_FORALL = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("FORALL", null, 2)));
      GuiServer.KWD_EXISTS = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("EXISTS", null, 2)));
      GuiServer.KWD_IMPLIES = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("IMPLIES", null, 2)));
      GuiServer.SYM_LOGIC_MASTER_PROPOSITION = ((Symbol)(GeneralizedSymbol.internRigidSymbolWrtModule("MASTER-PROPOSITION", Stella.getStellaModule("/LOGIC", true), 0)));
      GuiServer.SYM_STELLA_ASK = ((Symbol)(GeneralizedSymbol.internRigidSymbolWrtModule("ASK", Stella.getStellaModule("/STELLA", true), 0)));
      GuiServer.KWD_ORIGINAL = ((Keyword)(GeneralizedSymbol.internRigidSymbolWrtModule("ORIGINAL", null, 2)));
      GuiServer.SYM_GUI_SERVER_WILD = ((Symbol)(GeneralizedSymbol.internRigidSymbolWrtModule("WILD", null, 0)));
      GuiServer.SYM_GUI_SERVER_STARTUP_GUI_SERVER_API = ((Symbol)(GeneralizedSymbol.internRigidSymbolWrtModule("STARTUP-GUI-SERVER-API", null, 0)));
    }
  }

  static void helpStartupGuiServerApi2() {
    {
      Stella.defineFunctionObject("SERVER-LOG", "(DEFUN SERVER-LOG ((LOGLEVEL KEYWORD) |&REST| (MESSAGE OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "serverLog", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Keyword"), Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("PL-OBJECT-TO-GUI-NAME", "(DEFUN (PL-OBJECT-TO-GUI-NAME STRING) ((X OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "plObjectToGuiName", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
      Stella.defineFunctionObject("GUI-NAME-TO-PL-NAME", "(DEFUN (GUI-NAME-TO-PL-NAME STRING) ((NAME STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "guiNameToPlName", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SERVER-GET-MODULES", "(DEFUN (SERVER-GET-MODULES |PLModuleContainer|) () :DOCUMENTATION \"Get all the loaded modules, structured, hierarchically\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "serverGetModules", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("SERVER-GET-CONCEPTS-FOR-MODULE", "(DEFUN (SERVER-GET-CONCEPTS-FOR-MODULE |PLConceptContainer|) ((PLSTRING |PLString|)) :DOCUMENTATION \"Get all the concepts in a module, structured hierarchically\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetConceptsForModule", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-CONCEPT-COMPLETIONS", "(DEFUN (SERVER-GET-CONCEPT-COMPLETIONS |PLConceptContainer|) ((PLMODULE |PLString|) (PREFIX |PLString|)) :DOCUMENTATION \"Get all the concepts in a module and included/used modules that begin with 'prefix'\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetConceptCompletions", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-INSTANCES-FOR-MODULE", "(DEFUN (SERVER-GET-INSTANCES-FOR-MODULE |PLInstanceContainer|) ((PLSTRING |PLString|)) :DOCUMENTATION \"Get all the instances in a module, excluding skolems\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetInstancesForModule", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-INSTANCE-COMPLETIONS", "(DEFUN (SERVER-GET-INSTANCE-COMPLETIONS |PLInstanceContainer|) ((PLMODULE |PLString|) (PREFIX |PLString|)) :DOCUMENTATION \"Get all the instances begining with 'prefix' in all modules accessible from 'plModule'.\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetInstanceCompletions", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-RELATIONS-FOR-MODULE", "(DEFUN (SERVER-GET-RELATIONS-FOR-MODULE |PLRelationContainer|) ((PLSTRING |PLString|)) :DOCUMENTATION \"Get all the relations in a module, structured hierarchically\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetRelationsForModule", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-RELATION-COMPLETIONS", "(DEFUN (SERVER-GET-RELATION-COMPLETIONS |PLRelationContainer|) ((PLMODULE |PLString|) (PREFIX |PLString|)) :DOCUMENTATION \"Get all the relations in a module and included/used modules that begin with 'prefix'\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetRelationCompletions", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-INSTANCES-FOR-CONCEPT", "(DEFUN (SERVER-GET-INSTANCES-FOR-CONCEPT |PLInstanceContainer|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)) :DOCUMENTATION \"Get all the instances for a given module+concept\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetInstancesForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-DIRECT-INSTANCES-FOR-CONCEPT", "(DEFUN (SERVER-GET-DIRECT-INSTANCES-FOR-CONCEPT |PLInstanceContainer|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)) :DOCUMENTATION \"Get all the instances for a given module+concept\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetDirectInstancesForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-DOCUMENTATION-FOR-CONCEPT", "(DEFUN (SERVER-GET-DOCUMENTATION-FOR-CONCEPT |PLString|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)) :DOCUMENTATION \"Get the documentation string for module+concept\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetDocumentationForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-SOURCE-FOR-CONCEPT", "(DEFUN (SERVER-GET-SOURCE-FOR-CONCEPT |PLString|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)) :DOCUMENTATION \"Get the source string for module+concept\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetSourceForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-DOCUMENTATION-FOR-RELATION", "(DEFUN (SERVER-GET-DOCUMENTATION-FOR-RELATION |PLString|) ((MODULENAME |PLString|) (RELATIONNAME |PLString|)) :DOCUMENTATION \"Get the documentation string for module+relation\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetDocumentationForRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-SUPERCONCEPTS-FOR-CONCEPT", "(DEFUN (SERVER-GET-SUPERCONCEPTS-FOR-CONCEPT |PLSurrogateCollection|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)) :DOCUMENTATION \"Get the superconcepts for module+concept\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetSuperconceptsForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-SUPERRELATIONS-FOR-RELATION", "(DEFUN (SERVER-GET-SUPERRELATIONS-FOR-RELATION |PLSurrogateCollection|) ((MODULENAME |PLString|) (RELATIONNAME |PLString|)) :DOCUMENTATION \"Get the superrelations for module+relation\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetSuperrelationsForRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-INCLUDES-FOR-MODULE", "(DEFUN (SERVER-GET-INCLUDES-FOR-MODULE |PLSurrogateCollection|) ((MODULENAME |PLString|)) :DOCUMENTATION \"Get the includes for module\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetIncludesForModule", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-USES-FOR-MODULE", "(DEFUN (SERVER-GET-USES-FOR-MODULE |PLSurrogateCollection|) ((MODULENAME |PLString|)) :DOCUMENTATION \"Get the uses for module\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetUsesForModule", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-SHADOWED-SURROGATES-FOR-MODULE", "(DEFUN (SERVER-GET-SHADOWED-SURROGATES-FOR-MODULE |PLSurrogateCollection|) ((MODULENAME |PLString|)) :DOCUMENTATION \"Get the uses for module\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetShadowedSurrogatesForModule", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-VARIABLES-FOR-RELATION", "(DEFUN (SERVER-GET-VARIABLES-FOR-RELATION |PLVariableList|) ((MODULENAME |PLString|) (RELATIONNAME |PLString|)) :DOCUMENTATION \"Get the superrelations for module+relation\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetVariablesForRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-PROPOSITIONS-FOR-MODULE", "(DEFUN (SERVER-GET-PROPOSITIONS-FOR-MODULE |PLPropositionContainer|) ((MODULENAME |PLString|)) :DOCUMENTATION \"Get all the propositions for a given module\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetPropositionsForModule", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-RELATIONS-FOR-CONCEPT", "(DEFUN (SERVER-GET-RELATIONS-FOR-CONCEPT |PLRelationContainer|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)) :DOCUMENTATION \"Get all the direct relations which have 'conceptName' as their domain\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetRelationsForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-INHERITED-RELATIONS-FOR-CONCEPT", "(DEFUN (SERVER-GET-INHERITED-RELATIONS-FOR-CONCEPT |PLRelationContainer|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)) :DOCUMENTATION \"Get all the relations which have 'conceptName' as a subtype of their domain\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetInheritedRelationsForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-PROPOSITIONS-FOR-INSTANCE", "(DEFUN (SERVER-GET-PROPOSITIONS-FOR-INSTANCE |PLPropositionContainer|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)) :DOCUMENTATION \"Get all the propositions for a given instance\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetPropositionsForInstance", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-TYPES-FOR-INSTANCE", "(DEFUN (SERVER-GET-TYPES-FOR-INSTANCE |PLSurrogateCollection|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)) :DOCUMENTATION \"Get all the types of an instance.\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetTypesForInstance", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-DOCUMENTATION-FOR-INSTANCE", "(DEFUN (SERVER-GET-DOCUMENTATION-FOR-INSTANCE |PLString|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)) :DOCUMENTATION \"Get the documentation string for module+instance.\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetDocumentationForInstance", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-PROPOSITIONS-FOR-CONCEPT", "(DEFUN (SERVER-GET-PROPOSITIONS-FOR-CONCEPT |PLPropositionContainer|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)) :DOCUMENTATION \"Get all the propositions for a given concept\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetPropositionsForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-PROPOSITIONS-FOR-RELATION", "(DEFUN (SERVER-GET-PROPOSITIONS-FOR-RELATION |PLPropositionContainer|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)) :DOCUMENTATION \"Get all the propositions for a given relation\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetPropositionsForRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-RULES-FOR-CONCEPT", "(DEFUN (SERVER-GET-RULES-FOR-CONCEPT |PLPropositionContainer|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)) :DOCUMENTATION \"Get all the rules for a given concept\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetRulesForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-RULES-FOR-RELATION", "(DEFUN (SERVER-GET-RULES-FOR-RELATION |PLPropositionContainer|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)) :DOCUMENTATION \"Get all the rules for a given relation\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetRulesForRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-PROPOSITIONS-FOR-INSTANCE-AND-RELATION", "(DEFUN (SERVER-GET-PROPOSITIONS-FOR-INSTANCE-AND-RELATION |PLPropositionContainer|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|) (RELATIONNAME |PLString|)) :DOCUMENTATION \"Get all the propositions for a given instance and relation\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetPropositionsForInstanceAndRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-EVALUATE-LOGIC-COMMAND", "(DEFUN (SERVER-EVALUATE-LOGIC-COMMAND |PLString|) ((MODULENAME |PLString|) (COMMANDSTRING |PLString|)) :DOCUMENTATION \"Evaluate 'commandString' and return the result\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverEvaluateLogicCommand", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-LOADABLE-KBS", "(DEFUN (SERVER-GET-LOADABLE-KBS |PLModuleFileList|) () :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "serverGetLoadableKbs", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("SERVER-LOAD-KB", "(DEFUN (SERVER-LOAD-KB |PLString|) ((PLKBNAME |PLString|)) :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverLoadKb", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-LOAD-KB2", "(DEFUN (SERVER-LOAD-KB2 |PLString|) ((FILE |PLFile|)) :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLFile", "serverLoadKb2", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLFile")}), null);
      Stella.defineFunctionObject("SERVER-SAVE-KB", "(DEFUN (SERVER-SAVE-KB |PLString|) ((PLMODULENAME |PLString|) (PLKBNAME |PLString|) (PLDESCRIPTION |PLString|)) :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverSaveKb", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-SAVE-KB2", "(DEFUN (SERVER-SAVE-KB2 |PLFile|) ((PLMODULENAME |PLString|) (PLFILENAME |PLString|)) :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverSaveKb2", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-CLEAR-KB", "(DEFUN (SERVER-CLEAR-KB |PLString|) ((MODULE |PLModule|)) :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLModule", "serverClearKb", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLModule")}), null);
      Stella.defineFunctionObject("GET-QUERY-SESSION", "(DEFUN (GET-QUERY-SESSION /HTTP/SESSION) ((QUERY |PLQuery|) (ERROR? BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLQuery", "getQuerySession", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLQuery"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("SERVER-QUERY", "(DEFUN (SERVER-QUERY |PLQueryResult|) ((PLQUERY |PLQuery|) (CONTINUEQUERY? |PLString|)) :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLQuery", "serverQuery", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLQuery"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-SEARCH", "(DEFUN (SERVER-SEARCH |PLSearchResult|) ((SEARCHPARAMETER |PLSearchParameter|)) :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLSearchParameter", "serverSearch", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLSearchParameter")}), null);
      Stella.defineFunctionObject("SERVER-GET-EXTENSION-FOR-RELATION", "(DEFUN (SERVER-GET-EXTENSION-FOR-RELATION |PLQueryResult|) ((MODULENAME |PLString|) (RELATIONNAME |PLString|)) :DOCUMENTATION \"Get the extension for a relation\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetExtensionForRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-DESTROY-OBJECT", "(DEFUN (SERVER-DESTROY-OBJECT |PLString|) ((MODULENAME |PLString|) (OBJECTNAME |PLString|)) :DOCUMENTATION \"Destroy an object\" :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverDestroyObject", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-RELATION", "(DEFUN (SERVER-GET-RELATION |PLRelationContainer|) ((MODULENAME |PLString|) (RELATIONNAME |PLString|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-CONCEPT", "(DEFUN (SERVER-GET-CONCEPT |PLConceptContainer|) ((MODULENAME |PLString|) (CONCEPTNAME |PLString|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-INSTANCE", "(DEFUN (SERVER-GET-INSTANCE |PLInstanceContainer|) ((MODULENAME |PLString|) (INSTANCENAME |PLString|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetInstance", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-EXPLANATION-FOR-QUERY", "(DEFUN (SERVER-GET-EXPLANATION-FOR-QUERY |PLString|) ((QUERY |PLQuery|) (RESULTNUMBER |PLString|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLQuery", "serverGetExplanationForQuery", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLQuery"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-INFO", "(DEFUN (SERVER-GET-INFO |PLServerInfo|) () :DOCUMENTATION \"Return a data structure describing the characteristics and capabilities of this server instance.\")", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "serverGetInfo", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("EXTRACT-MODULE-NAME-FROM-STREAM", "(DEFUN (EXTRACT-MODULE-NAME-FROM-STREAM STRING) ((STREAM INPUT-STREAM)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "extractModuleNameFromStream", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.InputStream")}), null);
      Stella.defineFunctionObject("EXTRACT-MODULE-NAME-FROM-FILE", "(DEFUN (EXTRACT-MODULE-NAME-FROM-FILE STRING) ((FILENAME STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "extractModuleNameFromFile", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("CREATE-QUERY-STRING", "(DEFUN (CREATE-QUERY-STRING STRING) ((PLQUERY |PLQuery|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLQuery", "createQueryString", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLQuery")}), null);
      Stella.defineFunctionObject("CREATE-FOLLOWUP-QUERY-STRING", "(DEFUN (CREATE-FOLLOWUP-QUERY-STRING STRING) ((PLQUERY |PLQuery|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLQuery", "createFollowupQueryString", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLQuery")}), null);
      Stella.defineFunctionObject("MAKE-PL-TUPLE-FROM-PROPOSITION", "(DEFUN (MAKE-PL-TUPLE-FROM-PROPOSITION |PLTuple|) ((PROPOSITION PROPOSITION)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlTupleFromProposition", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Proposition")}), null);
      Stella.defineFunctionObject("MAKE-PL-TUPLE", "(DEFUN (MAKE-PL-TUPLE |PLTuple|) ((TUPLE (CONS OF OBJECT))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlTuple", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("MAKE-PL-OBJECT-UNION", "(DEFUN (MAKE-PL-OBJECT-UNION |PLObjectUnion|) ((OBJECT OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlObjectUnion", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Stella_Object")}), null);
      Stella.defineFunctionObject("GET-MODULES", "(DEFUN (GET-MODULES |PLModuleContainer|) ((MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getModules", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("CODE-MODULE?", "(DEFUN (CODE-MODULE? BOOLEAN) ((MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "codeModuleP", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("COLLECT-ALL-MODULES", "(DEFUN (COLLECT-ALL-MODULES (LIST OF MODULE)) ((MODULE MODULE) (COLLECTEDMODULES (LIST OF MODULE))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "collectAllModules", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), Native.find_java_class("edu.isi.stella.List")}), null);
      Stella.defineFunctionObject("CREATE-MODULE-CONTAINER", "(DEFUN (CREATE-MODULE-CONTAINER |PLModuleContainer|) ((COLLECTEDMODULES (LIST OF MODULE))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createModuleContainer", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List")}), null);
    }
  }

  static void helpStartupGuiServerApi3() {
    {
      Stella.defineFunctionObject("GET-STELLA-LITERAL-CONCEPTS", "(DEFUN (GET-STELLA-LITERAL-CONCEPTS (LIST OF NAMED-DESCRIPTION)) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getStellaLiteralConcepts", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("GET-STELLA-LITERAL-CONCEPTS-HELPER", "(DEFUN GET-STELLA-LITERAL-CONCEPTS-HELPER ((MODULE MODULE) (CONCEPT NAMED-DESCRIPTION) (COLLECTEDCONCEPTS (LIST OF NAMED-DESCRIPTION))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getStellaLiteralConceptsHelper", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), Native.find_java_class("edu.isi.powerloom.logic.NamedDescription"), Native.find_java_class("edu.isi.stella.List")}), null);
      Stella.defineFunctionObject("GET-CONCEPTS", "(DEFUN (GET-CONCEPTS |PLConceptContainer|) ((MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getConcepts", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("GET-CONCEPTS-WITH-PREFIX", "(DEFUN (GET-CONCEPTS-WITH-PREFIX |PLConceptContainer|) ((MODULE MODULE) (PREFIX STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getConceptsWithPrefix", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("CREATE-CONCEPT-CONTAINER", "(DEFUN (CREATE-CONCEPT-CONTAINER |PLConceptContainer|) ((COLLECTEDCONCEPTS (LIST OF DESCRIPTION)) (MODULE MODULE) (INCLUDECHILDREN? BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createConceptContainer", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List"), Native.find_java_class("edu.isi.stella.Module"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("GET-RELATIONS", "(DEFUN (GET-RELATIONS |PLRelationContainer|) ((MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getRelations", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("GET-RELATIONS-WITH-PREFIX", "(DEFUN (GET-RELATIONS-WITH-PREFIX |PLRelationContainer|) ((MODULE MODULE) (PREFIX STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getRelationsWithPrefix", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("CREATE-RELATION-CONTAINER", "(DEFUN (CREATE-RELATION-CONTAINER |PLRelationContainer|) ((COLLECTEDRELATIONS (LIST OF DESCRIPTION)) (MODULE MODULE) (INCLUDECHILDREN? BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createRelationContainer", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List"), Native.find_java_class("edu.isi.stella.Module"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("CREATE-MODULE-COLLECTION", "(DEFUN (CREATE-MODULE-COLLECTION |PLSurrogateCollection|) ((MODULES (LIST OF MODULE))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createModuleCollection", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List")}), null);
      Stella.defineFunctionObject("CREATE-SURROGATE-COLLECTION", "(DEFUN (CREATE-SURROGATE-COLLECTION |PLSurrogateCollection|) ((SURROGATES (LIST OF SURROGATE))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createSurrogateCollection", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List")}), null);
      Stella.defineFunctionObject("CREATE-SURROGATE-COLLECTION-FOR-LOGIC-OBJECT", "(DEFUN (CREATE-SURROGATE-COLLECTION-FOR-LOGIC-OBJECT |PLSurrogateCollection|) ((RELATIONS (LIST OF LOGIC-OBJECT))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createSurrogateCollectionForLogicObject", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List")}), null);
      Stella.defineFunctionObject("CREATE-SUPERRELATIONS-CONTAINER", "(DEFUN (CREATE-SUPERRELATIONS-CONTAINER |PLSurrogateCollection|) ((RELATION LOGIC-OBJECT) (MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createSuperrelationsContainer", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.LogicObject"), Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("CREATE-VARIABLES-LIST", "(DEFUN (CREATE-VARIABLES-LIST |PLVariableList|) ((RELATION LOGIC-OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "createVariablesList", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.LogicObject")}), null);
      Stella.defineFunctionObject("MAKE-PL-VARIABLE", "(DEFUN (MAKE-PL-VARIABLE |PLVariable|) ((VARIABLENAME STRING) (VARIABLETYPE SURROGATE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlVariable", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.Surrogate")}), null);
      Stella.defineFunctionObject("MAKE-PL-RELATION", "(DEFUN (MAKE-PL-RELATION |PLRelation|) ((RELATION LOGIC-OBJECT) (MODULENAME STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlRelation", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.LogicObject"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("MAKE-PL-CONCEPT", "(DEFUN (MAKE-PL-CONCEPT |PLConcept|) ((CONCEPT LOGIC-OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.LogicObject")}), null);
      Stella.defineFunctionObject("MAKE-PL-RELATIONS", "(DEFUN (MAKE-PL-RELATIONS (LIST OF |PLRelation|)) ((RELATIONS (LIST OF DESCRIPTION)) (MODULENAME STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlRelations", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("MAKE-MODULE-SURROGATE", "(DEFUN (MAKE-MODULE-SURROGATE |PLSurrogate|) ((MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makeModuleSurrogate", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("MAKE-SURROGATE-SURROGATE", "(DEFUN (MAKE-SURROGATE-SURROGATE |PLSurrogate|) ((SURROGATE SURROGATE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makeSurrogateSurrogate", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Surrogate")}), null);
      Stella.defineFunctionObject("MAKE-LOGIC-SURROGATE", "(DEFUN (MAKE-LOGIC-SURROGATE |PLSurrogate|) ((OBJ LOGIC-OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makeLogicSurrogate", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.LogicObject")}), null);
      Stella.defineFunctionObject("GET-ALL-RELATIONS", "(DEFUN (GET-ALL-RELATIONS (LIST OF DESCRIPTION)) ((MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getAllRelations", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("GET-ALL-RELATIONS-WITH-PREFIX", "(DEFUN (GET-ALL-RELATIONS-WITH-PREFIX (LIST OF DESCRIPTION)) ((MODULE MODULE) (LOCAL? BOOLEAN) (PREFIX STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getAllRelationsWithPrefix", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), java.lang.Boolean.TYPE, Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("GET-ALL-CONCEPTS", "(DEFUN (GET-ALL-CONCEPTS (LIST OF DESCRIPTION)) ((MODULE MODULE) (LOCAL? BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getAllConcepts", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("GET-ALL-CONCEPTS-WITH-PREFIX", "(DEFUN (GET-ALL-CONCEPTS-WITH-PREFIX (LIST OF DESCRIPTION)) ((MODULE MODULE) (LOCAL? BOOLEAN) (PREFIX STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getAllConceptsWithPrefix", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), java.lang.Boolean.TYPE, Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("GET-SUBCONCEPTS", "(DEFUN (GET-SUBCONCEPTS (LIST OF DESCRIPTION)) ((CONCEPT DESCRIPTION) (MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getSubconcepts", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Description"), Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("GET-SUBRELATIONS", "(DEFUN (GET-SUBRELATIONS (LIST OF DESCRIPTION)) ((RELATION DESCRIPTION) (MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getSubrelations", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Description"), Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("GET-SUPERCONCEPTS", "(DEFUN (GET-SUPERCONCEPTS (LIST OF DESCRIPTION)) ((CONCEPT DESCRIPTION) (MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getSuperconcepts", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Description"), Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("GET-SUPERRELATIONS", "(DEFUN (GET-SUPERRELATIONS (LIST OF DESCRIPTION)) ((RELATION DESCRIPTION) (MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getSuperrelations", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Description"), Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("MAKE-PL-INSTANCE", "(DEFUN (MAKE-PL-INSTANCE |PLInstance|) ((INSTANCE LOGIC-OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlInstance", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.LogicObject")}), null);
      Stella.defineFunctionObject("MAKE-PL-INSTANCES", "(DEFUN (MAKE-PL-INSTANCES (LIST OF |PLInstance|)) ((INSTANCES (LIST OF LOGIC-OBJECT)) (SKIPUNINTERNEDINSTANCES? BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlInstances", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("MAKE-PL-PROPOSITION", "(DEFUN (MAKE-PL-PROPOSITION |PLProposition|) ((PROPOSITION PROPOSITION) (MODULE MODULE) (ISRULE BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlProposition", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Proposition"), Native.find_java_class("edu.isi.stella.Module"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("MAKE-PL-PROPOSITIONS", "(DEFUN (MAKE-PL-PROPOSITIONS (LIST OF |PLProposition|)) ((PROPOSITIONS (LIST OF PROPOSITION)) (MODULE MODULE) (ISRULE BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlPropositions", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.List"), Native.find_java_class("edu.isi.stella.Module"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("GET-DOCUMENTATION-FOR-OBJECT", "(DEFUN (GET-DOCUMENTATION-FOR-OBJECT |PLString|) ((MODULENAME STRING) (OBJECTNAME STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getDocumentationForObject", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("GET-DIRECT-RELATIONS-FOR-CONCEPT", "(DEFUN (GET-DIRECT-RELATIONS-FOR-CONCEPT (LIST OF DESCRIPTION)) ((MODULE MODULE) (CONCEPT LOGIC-OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getDirectRelationsForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), Native.find_java_class("edu.isi.powerloom.logic.LogicObject")}), null);
      Stella.defineFunctionObject("GET-INHERITED-RELATIONS-FOR-CONCEPT", "(DEFUN (GET-INHERITED-RELATIONS-FOR-CONCEPT (LIST OF DESCRIPTION)) ((MODULE MODULE) (CONCEPT LOGIC-OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getInheritedRelationsForConcept", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module"), Native.find_java_class("edu.isi.powerloom.logic.LogicObject")}), null);
      Stella.defineFunctionObject("GET-PROPOSITIONS-FOR-OBJECT", "(DEFUN (GET-PROPOSITIONS-FOR-OBJECT (LIST OF PROPOSITION)) ((MODULENAME STRING) (INSTANCENAME STRING) (RELATION? BOOLEAN)) :DOCUMENTATION \"Get all the propositions for a given instance\")", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getPropositionsForObject", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("GET-RULES-FOR-RELATION", "(DEFUN (GET-RULES-FOR-RELATION (LIST OF PROPOSITION)) ((MODULENAME STRING) (INSTANCENAME STRING)) :DOCUMENTATION \"Get all the rules for a given logic object\")", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getRulesForRelation", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("RULE-PROPOSITION?", "(DEFUN (RULE-PROPOSITION? BOOLEAN) ((PROPOSITION PROPOSITION)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "rulePropositionP", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Proposition")}), null);
      Stella.defineFunctionObject("SUBRELATION-RULE?", "(DEFUN (SUBRELATION-RULE? BOOLEAN) ((RULE PROPOSITION)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "subrelationRuleP", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Proposition")}), null);
      Stella.defineFunctionObject("GET-RELEVANT-RULES-FOR-RELATION", "(DEFUN (GET-RELEVANT-RULES-FOR-RELATION (LIST OF PROPOSITION)) ((MODULENAME STRING) (RELATIONNAME STRING)) :DOCUMENTATION \"Get all the relevant rules for a given logic object.\")", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getRelevantRulesForRelation", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("GET-PROPOSITIONS-FOR-INSTANCE-AND-RELATION", "(DEFUN (GET-PROPOSITIONS-FOR-INSTANCE-AND-RELATION (LIST OF PROPOSITION)) ((MODULENAME STRING) (INSTANCENAME STRING) (RELATIONNAME STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getPropositionsForInstanceAndRelation", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("EVALUATE-LOGIC-COMMAND-IN-MODULE", "(DEFUN (EVALUATE-LOGIC-COMMAND-IN-MODULE STRING) ((COMMAND STRING) (MODULENAME STRING) (FINALIZE? BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "evaluateLogicCommandInModule", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("IS-QUERY-PARTIAL?", "(DEFUN (IS-QUERY-PARTIAL? BOOLEAN) ((PLQUERY |PLQuery|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLQuery", "isQueryPartialP", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLQuery")}), null);
      Stella.defineFunctionObject("EVALUATE-QUERY-COMMAND-IN-MODULE", "(DEFUN (EVALUATE-QUERY-COMMAND-IN-MODULE CONS) ((SESSION /HTTP/SESSION) (QUERY STRING) (MODULENAME STRING) (CONTINUATIONQUERY? BOOLEAN) (PARTIALQUERY? BOOLEAN)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "evaluateQueryCommandInModule", new java.lang.Class [] {Native.find_java_class("edu.isi.webtools.http.Session"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), java.lang.Boolean.TYPE, java.lang.Boolean.TYPE}), null);
      Stella.defineFunctionObject("GET-PROPOSITION-STRING", "(DEFUN (GET-PROPOSITION-STRING STRING) ((PROP PROPOSITION) (MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getPropositionString", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.Proposition"), Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("GET-TRUTH-VALUE-STRING", "(DEFUN (GET-TRUTH-VALUE-STRING STRING) ((TV TRUTH-VALUE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getTruthValueString", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.TruthValue")}), null);
      Stella.defineFunctionObject("XMLIFY-STRING", "(DEFUN (XMLIFY-STRING STRING) ((INSTRING STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "xmlifyString", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("XMLIFY-FORMATTED-STRING", "(DEFUN (XMLIFY-FORMATTED-STRING STRING) ((INSTRING STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "xmlifyFormattedString", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("GET-STRINGIFIED-MODULE", "(DEFUN (GET-STRINGIFIED-MODULE STRING) ((MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getStringifiedModule", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("REPLACE-CHOKABLE-CHARS-WITH-ENTITIES", "(DEFUN (REPLACE-CHOKABLE-CHARS-WITH-ENTITIES STRING) ((INSTRING STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "replaceChokableCharsWithEntities", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("WRITE-HTML-CHARACTER-QUOTING-CHOKABLE-CHARACTERS", "(DEFUN WRITE-HTML-CHARACTER-QUOTING-CHOKABLE-CHARACTERS ((STREAM NATIVE-OUTPUT-STREAM) (CH CHARACTER)) :GLOBALLY-INLINE? TRUE (IF (OR (= (CHARACTER-CODE CH) 10) (> (CHARACTER-CODE CH) 127)) (PRINT-STREAM STREAM \"&#\" (CHARACTER-CODE CH) \";\") (WRITE-HTML-CHARACTER-QUOTING-SPECIAL-CHARACTERS STREAM CH)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "writeHtmlCharacterQuotingChokableCharacters", new java.lang.Class [] {Native.find_java_class("java.io.PrintStream"), java.lang.Character.TYPE}), null);
      Stella.defineFunctionObject("WRITE-HTML-QUOTING-CHOKABLE-CHARACTERS", "(DEFUN WRITE-HTML-QUOTING-CHOKABLE-CHARACTERS ((STREAM NATIVE-OUTPUT-STREAM) (INPUT STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "writeHtmlQuotingChokableCharacters", new java.lang.Class [] {Native.find_java_class("java.io.PrintStream"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("COMPACT-WHITESPACE", "(DEFUN (COMPACT-WHITESPACE STRING) ((INSTRING STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "compactWhitespace", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("STRIP-NEWLINES", "(DEFUN (STRIP-NEWLINES STRING) ((INSTRING STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "stripNewlines", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("STRIP-MODULE", "(DEFUN (STRIP-MODULE STRING) ((INSTRING STRING) (MODULE MODULE)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "stripModule", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.Module")}), null);
      Stella.defineFunctionObject("REPLACE-DOUBLE-QUOTES-WITH-SINGLE-QUOTES", "(DEFUN (REPLACE-DOUBLE-QUOTES-WITH-SINGLE-QUOTES STRING) ((INSTRING STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "replaceDoubleQuotesWithSingleQuotes", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("LOAD-INDEX-FILE", "(DEFUN (LOAD-INDEX-FILE (CONS OF (CONS OF STRING-WRAPPER))) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "loadIndexFile", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("SAVE-INDEX-FILE", "(DEFUN SAVE-INDEX-FILE ((INDEX (CONS OF (CONS OF STRING-WRAPPER)))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "saveIndexFile", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("MAKE-PL-FILE", "(DEFUN (MAKE-PL-FILE |PLModuleFile|) ((FILEDESCRIPTION (CONS OF STRING-WRAPPER))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlFile", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("FIND-FILENAME-FOR-KB", "(DEFUN (FIND-FILENAME-FOR-KB STRING) ((FILEINDEX |PLModuleFileList|) (KBNAME STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLModuleFileList", "findFilenameForKb", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLModuleFileList"), Native.find_java_class("java.lang.String")}), null);
    }
  }

  static void helpStartupGuiServerApi4() {
    {
      Stella.defineFunctionObject("PARSE-MATCH-STRING", "(DEFUN (PARSE-MATCH-STRING (CONS OF OBJECT)) ((MATCHSTRING STRING) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "parseMatchString", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SEARCH-STRING-MATCH?", "(DEFUN (SEARCH-STRING-MATCH? BOOLEAN) ((INPUTSTRING STRING) (MATCHLIST (CONS OF OBJECT))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "searchStringMatchP", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("GET-FIRST-NON-WILD", "(DEFUN (GET-FIRST-NON-WILD STRING-WRAPPER) ((MATCHLIST (CONS OF OBJECT))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getFirstNonWild", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("GET-REST-AFTER-FIRST-NON-WILD", "(DEFUN (GET-REST-AFTER-FIRST-NON-WILD (CONS OF OBJECT)) ((MATCHLIST (CONS OF OBJECT))))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getRestAfterFirstNonWild", new java.lang.Class [] {Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("SEARCH-LOGIC-OBJECTS", "(DEFUN (SEARCH-LOGIC-OBJECTS (LIST OF |PLSearchResultItem|)) ((MODULENAME STRING) (OBJECTS (LIST OF LOGIC-OBJECT)) (MATCHLIST (CONS OF OBJECT)) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "searchLogicObjects", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.List"), Native.find_java_class("edu.isi.stella.Cons"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("GET-LOGIC-OBJECT-NAME", "(DEFUN (GET-LOGIC-OBJECT-NAME STRING) ((OBJECT LOGIC-OBJECT) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getLogicObjectName", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.logic.LogicObject"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SEARCH-CONCEPTS", "(DEFUN (SEARCH-CONCEPTS (LIST OF |PLSearchResultItem|)) ((MODULENAME STRING) (MATCHLIST (CONS OF OBJECT)) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "searchConcepts", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.Cons"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SEARCH-RELATIONS", "(DEFUN (SEARCH-RELATIONS (LIST OF |PLSearchResultItem|)) ((MODULENAME STRING) (MATCHLIST (CONS OF OBJECT)) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "searchRelations", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.Cons"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SEARCH-INSTANCES", "(DEFUN (SEARCH-INSTANCES (LIST OF |PLSearchResultItem|)) ((MODULENAME STRING) (MATCHLIST (CONS OF OBJECT)) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "searchInstances", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.Cons"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SEARCH-ALL-MODULES", "(DEFUN (SEARCH-ALL-MODULES (LIST OF |PLSearchResultItem|)) ((SEARCHSTRING STRING) (SEARCHINSTANCE? STRING) (SEARCHCONCEPT? STRING) (SEARCHRELATION? STRING) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "searchAllModules", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SEARCH-MODULE", "(DEFUN (SEARCH-MODULE (LIST OF |PLSearchResultItem|)) ((MODULENAME STRING) (SEARCHSTRING STRING) (SEARCHINSTANCE? STRING) (SEARCHCONCEPT? STRING) (SEARCHRELATION? STRING) (CASESENSITIVE? STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "searchModule", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String"), Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("MAKE-SEARCH-RESULT-ITEM", "(DEFUN (MAKE-SEARCH-RESULT-ITEM |PLSearchResultItem|) ((MODULENAME STRING) (OBJECT LOGIC-OBJECT)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makeSearchResultItem", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.powerloom.logic.LogicObject")}), null);
      Stella.defineFunctionObject("GET-DIRECTORY-LISTING", "(DEFUN (GET-DIRECTORY-LISTING (LIST OF LIST)) ((CURRENTDIRECTORY STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "getDirectoryListing", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("SERVER-GET-DIRECTORY-LISTING", "(DEFUN (SERVER-GET-DIRECTORY-LISTING |PLDirectoryContents|) ((CURRENTDIRECTORY |PLString|) (EXTENSIONFILTER |PLString|)) :PUBLIC? TRUE :DOCUMENTATION \"Return the files and directories in 'currentDirectory'.\")", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetDirectoryListing", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString"), Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("SERVER-GET-DEFAULT-DIRECTORY-LISTING", "(DEFUN (SERVER-GET-DEFAULT-DIRECTORY-LISTING |PLDirectoryContents|) ((EXTENSIONFILTER |PLString|)) :PUBLIC? TRUE :DOCUMENTATION \"Return the files and directories in the directory designated by '*DEFAULT-KB-DIRECTORY*'.\")", Native.find_java_method("edu.isi.powerloom.server.gui.PLString", "serverGetDefaultDirectoryListing", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLString")}), null);
      Stella.defineFunctionObject("DISPATCH-CALL", "(DEFUN (DISPATCH-CALL OBJECT) ((FUNCTIONNAME STRING) (ARGS CONS)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "dispatchCall", new java.lang.Class [] {Native.find_java_class("java.lang.String"), Native.find_java_class("edu.isi.stella.Cons")}), null);
      Stella.defineFunctionObject("INITIALIZE-DISPATCH-TABLE", "(DEFUN INITIALIZE-DISPATCH-TABLE ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "initializeDispatchTable", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("MEMBER-TEST", "(DEFUN MEMBER-TEST ((CONCEPT |PLConcept|)))", Native.find_java_method("edu.isi.powerloom.server.gui.PLConcept", "memberTest", new java.lang.Class [] {Native.find_java_class("edu.isi.powerloom.server.gui.PLConcept")}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-CONCEPTS-FOR-MODULE", "(DEFUN (TEST-SERVER-GET-CONCEPTS-FOR-MODULE |PLConceptContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetConceptsForModule", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-INSTANCES-FOR-MODULE", "(DEFUN (TEST-SERVER-GET-INSTANCES-FOR-MODULE |PLInstanceContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetInstancesForModule", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-RELATIONS-FOR-MODULE", "(DEFUN (TEST-SERVER-GET-RELATIONS-FOR-MODULE |PLRelationContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetRelationsForModule", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-DIRECT-INSTANCES-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-DIRECT-INSTANCES-FOR-CONCEPT |PLInstanceContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetDirectInstancesForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-INSTANCES-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-INSTANCES-FOR-CONCEPT |PLInstanceContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetInstancesForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-PROPOSITIONS-FOR-MODULE", "(DEFUN (TEST-SERVER-GET-PROPOSITIONS-FOR-MODULE |PLPropositionContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetPropositionsForModule", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-PROPOSITIONS-FOR-INSTANCE", "(DEFUN (TEST-SERVER-GET-PROPOSITIONS-FOR-INSTANCE |PLPropositionContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetPropositionsForInstance", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-TYPES-FOR-INSTANCE", "(DEFUN (TEST-SERVER-GET-TYPES-FOR-INSTANCE |PLSurrogateCollection|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetTypesForInstance", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-DOCUMENTATION-FOR-INSTANCE", "(DEFUN (TEST-SERVER-GET-DOCUMENTATION-FOR-INSTANCE |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetDocumentationForInstance", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-RELATIONS-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-RELATIONS-FOR-CONCEPT |PLRelationContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetRelationsForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-INHERITED-RELATIONS-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-INHERITED-RELATIONS-FOR-CONCEPT |PLRelationContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetInheritedRelationsForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-DOCUMENTATION-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-DOCUMENTATION-FOR-CONCEPT |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetDocumentationForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-SOURCE-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-SOURCE-FOR-CONCEPT |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetSourceForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-DOCUMENTATION-FOR-RELATION", "(DEFUN (TEST-SERVER-GET-DOCUMENTATION-FOR-RELATION |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetDocumentationForRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-SUPERCONCEPTS-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-SUPERCONCEPTS-FOR-CONCEPT |PLSurrogateCollection|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetSuperconceptsForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-SUPERRELATIONS-FOR-RELATION", "(DEFUN (TEST-SERVER-GET-SUPERRELATIONS-FOR-RELATION |PLSurrogateCollection|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetSuperrelationsForRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-INCLUDES-FOR-MODULE", "(DEFUN (TEST-SERVER-GET-INCLUDES-FOR-MODULE |PLSurrogateCollection|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetIncludesForModule", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-SHADOWED-SURROGATES-FOR-MODULE", "(DEFUN (TEST-SERVER-GET-SHADOWED-SURROGATES-FOR-MODULE |PLSurrogateCollection|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetShadowedSurrogatesForModule", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-USES-FOR-MODULE", "(DEFUN (TEST-SERVER-GET-USES-FOR-MODULE |PLSurrogateCollection|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetUsesForModule", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-VARIABLES-FOR-RELATION", "(DEFUN (TEST-SERVER-GET-VARIABLES-FOR-RELATION |PLVariableList|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetVariablesForRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-PROPOSITIONS-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-PROPOSITIONS-FOR-CONCEPT |PLPropositionContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetPropositionsForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-RULES-FOR-CONCEPT", "(DEFUN (TEST-SERVER-GET-RULES-FOR-CONCEPT |PLPropositionContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetRulesForConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-PROPOSITIONS-FOR-RELATION", "(DEFUN (TEST-SERVER-GET-PROPOSITIONS-FOR-RELATION |PLPropositionContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetPropositionsForRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-RULES-FOR-RELATION", "(DEFUN (TEST-SERVER-GET-RULES-FOR-RELATION |PLPropositionContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetRulesForRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-PROPOSITIONS-FOR-INSTANCE-AND-RELATION", "(DEFUN (TEST-SERVER-GET-PROPOSITIONS-FOR-INSTANCE-AND-RELATION |PLPropositionContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetPropositionsForInstanceAndRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-EVALUATE-LOGIC-COMMAND", "(DEFUN (TEST-SERVER-EVALUATE-LOGIC-COMMAND |PLString|) ((COMMAND STRING)))", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerEvaluateLogicCommand", new java.lang.Class [] {Native.find_java_class("java.lang.String")}), null);
      Stella.defineFunctionObject("TEST-SERVER-LOAD-KB", "(DEFUN (TEST-SERVER-LOAD-KB |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerLoadKb", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-CLEAR-KB", "(DEFUN TEST-SERVER-CLEAR-KB ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerClearKb", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-SAVE-KB", "(DEFUN (TEST-SERVER-SAVE-KB |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerSaveKb", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-SAVE-KB2", "(DEFUN (TEST-SERVER-SAVE-KB2 |PLFile|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerSaveKb2", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("MAKE-PL-QUERY", "(DEFUN (MAKE-PL-QUERY |PLQuery|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "makePlQuery", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-QUERY", "(DEFUN (TEST-SERVER-QUERY |PLQueryResult|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerQuery", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-SEARCH1", "(DEFUN (TEST-SERVER-SEARCH1 |PLSearchResult|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerSearch1", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-DEFAULT-DIRECTORY-LISTING", "(DEFUN (TEST-SERVER-GET-DEFAULT-DIRECTORY-LISTING |PLDirectoryContents|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetDefaultDirectoryListing", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-EXTENSION-FOR-RELATION", "(DEFUN (TEST-SERVER-GET-EXTENSION-FOR-RELATION |PLQueryResult|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetExtensionForRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-RELATION", "(DEFUN (TEST-SERVER-GET-RELATION |PLRelationContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetRelation", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-CONCEPT", "(DEFUN (TEST-SERVER-GET-CONCEPT |PLConceptContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetConcept", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-INSTANCE", "(DEFUN (TEST-SERVER-GET-INSTANCE |PLInstanceContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetInstance", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-CONCEPT-COMPLETIONS", "(DEFUN (TEST-SERVER-GET-CONCEPT-COMPLETIONS |PLConceptContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetConceptCompletions", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-RELATION-COMPLETIONS", "(DEFUN (TEST-SERVER-GET-RELATION-COMPLETIONS |PLRelationContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetRelationCompletions", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-GET-INSTANCE-COMPLETIONS", "(DEFUN (TEST-SERVER-GET-INSTANCE-COMPLETIONS |PLInstanceContainer|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetInstanceCompletions", new java.lang.Class [] {}), null);
      Stella.defineFunctionObject("TEST-SERVER-DESTROY-OBJECT", "(DEFUN (TEST-SERVER-DESTROY-OBJECT |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerDestroyObject", new java.lang.Class [] {}), null);
    }
  }

  public static void startupGuiServerApi() {
    { Object old$Module$000 = Stella.$MODULE$.get();
      Object old$Context$000 = Stella.$CONTEXT$.get();

      try {
        Native.setSpecial(Stella.$MODULE$, Stella.getStellaModule("/POWERLOOM-SERVER/GUI-SERVER", Stella.$STARTUP_TIME_PHASE$ > 1));
        Native.setSpecial(Stella.$CONTEXT$, ((Module)(Stella.$MODULE$.get())));
        if (Stella.currentStartupTimePhaseP(2)) {
          _StartupGuiServerApi.helpStartupGuiServerApi1();
        }
        if (Stella.currentStartupTimePhaseP(4)) {
          GuiServer.$SERVER_DISPATCH_TABLE$ = StringHashTable.newStringHashTable();
        }
        if (Stella.currentStartupTimePhaseP(6)) {
          Stella.finalizeClasses();
        }
        if (Stella.currentStartupTimePhaseP(7)) {
          _StartupGuiServerApi.helpStartupGuiServerApi2();
          _StartupGuiServerApi.helpStartupGuiServerApi3();
          _StartupGuiServerApi.helpStartupGuiServerApi4();
          Stella.defineFunctionObject("TEST-SERVER-GET-EXPLANATION-FOR-QUERY", "(DEFUN (TEST-SERVER-GET-EXPLANATION-FOR-QUERY |PLString|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetExplanationForQuery", new java.lang.Class [] {}), null);
          Stella.defineFunctionObject("TEST-SERVER-GET-INFO", "(DEFUN (TEST-SERVER-GET-INFO |PLServerInfo|) ())", Native.find_java_method("edu.isi.powerloom.server.gui.GuiServer", "testServerGetInfo", new java.lang.Class [] {}), null);
          Stella.defineFunctionObject("STARTUP-GUI-SERVER-API", "(DEFUN STARTUP-GUI-SERVER-API () :PUBLIC? TRUE)", Native.find_java_method("edu.isi.powerloom.server.gui._StartupGuiServerApi", "startupGuiServerApi", new java.lang.Class [] {}), null);
          { MethodSlot function = Symbol.lookupFunction(GuiServer.SYM_GUI_SERVER_STARTUP_GUI_SERVER_API);

            KeyValueList.setDynamicSlotValue(function.dynamicSlots, GuiServer.SYM_STELLA_METHOD_STARTUP_CLASSNAME, StringWrapper.wrapString("_StartupGuiServerApi"), Stella.NULL_STRING_WRAPPER);
          }
        }
        if (Stella.currentStartupTimePhaseP(8)) {
          Stella.finalizeSlots();
          Stella.cleanupUnfinalizedClasses();
        }
        if (Stella.currentStartupTimePhaseP(9)) {
          Stella_Object.inModule(((StringWrapper)(Stella_Object.copyConsTree(StringWrapper.wrapString("GUI-SERVER")))));
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *ALLOW-REMOTE-FILEBROWSING* BOOLEAN FALSE)");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *SERVER-LOG-FILE* STRING \"PL:logs;powerloom-server.log\")");
          Stella.setLoggingParameters("PL-Server", Cons.cons(GuiServer.KWD_LOG_LEVELS, Cons.cons(Stella.getQuotedTree("((:NONE :LOW :MEDIUM :HIGH) \"/POWERLOOM-SERVER/GUI-SERVER\")", "/POWERLOOM-SERVER/GUI-SERVER"), Cons.cons(GuiServer.KWD_LEVEL, Cons.cons(((Logic.$POWERLOOM_EXECUTION_MODE$ == GuiServer.KWD_DEVELOPMENT) ? GuiServer.KWD_HIGH : GuiServer.KWD_LOW), Cons.cons(GuiServer.KWD_PREFIX, Cons.cons(StringWrapper.wrapString("PL-Server"), Cons.cons(GuiServer.KWD_MAX_WIDTH, Cons.cons(IntegerWrapper.wrapInteger(2000), Cons.cons(GuiServer.KWD_STREAM, Cons.cons(StringWrapper.wrapString(GuiServer.$SERVER_LOG_FILE$), Stella.NIL)))))))))));
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *QUERY-SESSION-TIMEOUT* INTEGER 86400)");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *KB-FILENAME-INDEX* STRING \"PL:kbs;kbs.ste\")");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *KB-DIRECTORY* STRING \"PL:kbs;\")");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *DEFAULT-KB-DIRECTORY* STRING \"/nfs/topaz/melz/\")");
          Stella.defineStellaGlobalVariableFromStringifiedSource("(DEFGLOBAL *SERVER-DISPATCH-TABLE* (STRING-HASH-TABLE OF STRING FUNCTION-CODE-WRAPPER) (NEW (STRING-HASH-TABLE OF STRING FUNCTION-CODE-WRAPPER)) :DOCUMENTATION \"Hash Table for used for dispatching server API methods.\")");
          GuiServer.initializeDispatchTable();
        }

      } finally {
        Stella.$CONTEXT$.set(old$Context$000);
        Stella.$MODULE$.set(old$Module$000);
      }
    }
  }

}
