//  -*- Mode: Java -*-
//
// FunctionCodeWrapper.java

/*
+---------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2014      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK -----------------------------+
*/

package edu.isi.stella;

import edu.isi.stella.javalib.*;

public class FunctionCodeWrapper extends CodeWrapper {
    public java.lang.reflect.Method wrapperValue;

  /** Return a literal object whose value is the FUNCTION-CODE 'value'.
   * @param value
   * @return FunctionCodeWrapper
   */
  public static FunctionCodeWrapper wrapFunctionCode(java.lang.reflect.Method value) {
    if (value == null) {
      return (Stella.NULL_FUNCTION_CODE_WRAPPER);
    }
    else {
      return (FunctionCodeWrapper.newFunctionCodeWrapper(value));
    }
  }

  public static FunctionCodeWrapper newFunctionCodeWrapper(java.lang.reflect.Method wrapperValue) {
    { FunctionCodeWrapper self = null;

      self = new FunctionCodeWrapper();
      self.wrapperValue = wrapperValue;
      return (self);
    }
  }

  public Stella_Object copyWrappedLiteral() {
    { FunctionCodeWrapper self = this;

      return (FunctionCodeWrapper.wrapFunctionCode(self.wrapperValue));
    }
  }

  /** Unwrap <code>wrapper</code> and return the result.
   * Return NULL if <code>wrapper</code> is NULL.
   * @param wrapper
   * @return java.lang.reflect.Method
   */
  public static java.lang.reflect.Method unwrapFunctionCode(FunctionCodeWrapper wrapper) {
    if (wrapper == null) {
      return (null);
    }
    else {
      return (wrapper.wrapperValue);
    }
  }

  public static Stella_Object accessFunctionCodeWrapperSlotValue(FunctionCodeWrapper self, Symbol slotname, Stella_Object value, boolean setvalueP) {
    if (slotname == Stella.SYM_STELLA_WRAPPER_VALUE) {
      if (setvalueP) {
        self.wrapperValue = ((FunctionCodeWrapper)(value)).wrapperValue;
      }
      else {
        value = FunctionCodeWrapper.wrapFunctionCode(self.wrapperValue);
      }
    }
    else {
      { OutputStringStream stream000 = OutputStringStream.newOutputStringStream();

        stream000.nativeStream.print("`" + slotname + "' is not a valid case option");
        throw ((StellaException)(StellaException.newStellaException(stream000.theStringReader()).fillInStackTrace()));
      }
    }
    return (value);
  }

  public Surrogate primaryType() {
    { FunctionCodeWrapper self = this;

      return (Stella.SGT_STELLA_FUNCTION_CODE_WRAPPER);
    }
  }

}

