//  -*- Mode: Java -*-
//
// PolymorphicRelation.java

/*
+---------------------------- BEGIN LICENSE BLOCK ---------------------------+
|                                                                            |
| Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
|                                                                            |
| The contents of this file are subject to the Mozilla Public License        |
| Version 1.1 (the "License"); you may not use this file except in           |
| compliance with the License. You may obtain a copy of the License at       |
| http://www.mozilla.org/MPL/                                                |
|                                                                            |
| Software distributed under the License is distributed on an "AS IS" basis, |
| WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
| for the specific language governing rights and limitations under the       |
| License.                                                                   |
|                                                                            |
| The Original Code is the STELLA Programming Language.                      |
|                                                                            |
| The Initial Developer of the Original Code is                              |
| UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
| 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
|                                                                            |
| Portions created by the Initial Developer are Copyright (C) 1996-2014      |
| the Initial Developer. All Rights Reserved.                                |
|                                                                            |
| Contributor(s):                                                            |
|                                                                            |
| Alternatively, the contents of this file may be used under the terms of    |
| either the GNU General Public License Version 2 or later (the "GPL"), or   |
| the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
| in which case the provisions of the GPL or the LGPL are applicable instead |
| of those above. If you wish to allow use of your version of this file only |
| under the terms of either the GPL or the LGPL, and not to allow others to  |
| use your version of this file under the terms of the MPL, indicate your    |
| decision by deleting the provisions above and replace them with the notice |
| and other provisions required by the GPL or the LGPL. If you do not delete |
| the provisions above, a recipient may use your version of this file under  |
| the terms of any one of the MPL, the GPL or the LGPL.                      |
|                                                                            |
+---------------------------- END LICENSE BLOCK -----------------------------+
*/

package edu.isi.stella;

import edu.isi.stella.javalib.*;

public abstract class PolymorphicRelation extends Relation {
    public Slot slotDirectEquivalent;

  public static Stella_Object accessPolymorphicRelationSlotValue(PolymorphicRelation self, Symbol slotname, Stella_Object value, boolean setvalueP) {
    if (slotname == Stella.SYM_STELLA_SLOT_DIRECT_EQUIVALENT) {
      if (setvalueP) {
        self.slotDirectEquivalent = ((Slot)(value));
      }
      else {
        value = self.slotDirectEquivalent;
      }
    }
    else {
      if (setvalueP) {
        KeyValueList.setDynamicSlotValue(self.dynamicSlots, slotname, value, null);
      }
      else {
        value = self.dynamicSlots.lookup(slotname);
      }
    }
    return (value);
  }

  /** True if <code>self</code> or a superslot of <code>self</code> is marked active.
   * @return boolean
   */
  public boolean activeP() {
    { PolymorphicRelation self = this;

      { PolymorphicRelation cursor = self;
        BooleanWrapper value = ((BooleanWrapper)(KeyValueList.dynamicSlotValue(cursor.dynamicSlots, Stella.SYM_STELLA_STORED_ACTIVEp, null)));

        for (;;) {
          if (value != null) {
            return (BooleanWrapper.coerceWrappedBooleanToBoolean(value));
          }
          cursor = cursor.slotDirectEquivalent;
          if (cursor != null) {
            value = ((BooleanWrapper)(KeyValueList.dynamicSlotValue(cursor.dynamicSlots, Stella.SYM_STELLA_STORED_ACTIVEp, null)));
          }
          else {
            return (false);
          }
        }
      }
    }
  }

  public Symbol renames() {
    { PolymorphicRelation self = this;

      return (null);
    }
  }

  public Surrogate owner() {
    { PolymorphicRelation self = this;

      return (null);
    }
  }

}

