;;; -*- Mode: Lisp; Package: STELLA; Syntax: COMMON-LISP; Base: 10 -*-

;;; extensions.lisp

#|
 +---------------------------- BEGIN LICENSE BLOCK ---------------------------+
 |                                                                            |
 | Version: MPL 1.1/GPL 2.0/LGPL 2.1                                          |
 |                                                                            |
 | The contents of this file are subject to the Mozilla Public License        |
 | Version 1.1 (the "License"); you may not use this file except in           |
 | compliance with the License. You may obtain a copy of the License at       |
 | http://www.mozilla.org/MPL/                                                |
 |                                                                            |
 | Software distributed under the License is distributed on an "AS IS" basis, |
 | WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License   |
 | for the specific language governing rights and limitations under the       |
 | License.                                                                   |
 |                                                                            |
 | The Original Code is the PowerLoom KR&R System.                            |
 |                                                                            |
 | The Initial Developer of the Original Code is                              |
 | UNIVERSITY OF SOUTHERN CALIFORNIA, INFORMATION SCIENCES INSTITUTE          |
 | 4676 Admiralty Way, Marina Del Rey, California 90292, U.S.A.               |
 |                                                                            |
 | Portions created by the Initial Developer are Copyright (C) 1997-2014      |
 | the Initial Developer. All Rights Reserved.                                |
 |                                                                            |
 | Contributor(s):                                                            |
 |                                                                            |
 | Alternatively, the contents of this file may be used under the terms of    |
 | either the GNU General Public License Version 2 or later (the "GPL"), or   |
 | the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),   |
 | in which case the provisions of the GPL or the LGPL are applicable instead |
 | of those above. If you wish to allow use of your version of this file only |
 | under the terms of either the GPL or the LGPL, and not to allow others to  |
 | use your version of this file under the terms of the MPL, indicate your    |
 | decision by deleting the provisions above and replace them with the notice |
 | and other provisions required by the GPL or the LGPL. If you do not delete |
 | the provisions above, a recipient may use your version of this file under  |
 | the terms of any one of the MPL, the GPL or the LGPL.                      |
 |                                                                            |
 +----------------------------- END LICENSE BLOCK ----------------------------+
|#

(CL:IN-PACKAGE "STELLA")

;;; Auxiliary variables:

(CL:DEFVAR KWD-EXTENSIONS-DOCUMENTATION NULL)
(CL:DEFVAR SYM-EXTENSIONS-PLX-STARTUP-EXTENSIONS NULL)
(CL:DEFVAR SYM-EXTENSIONS-STELLA-METHOD-STARTUP-CLASSNAME NULL)

;;; Forward declarations:

(CL:DECLAIM
 (CL:SPECIAL *STARTUP-TIME-PHASE* *MODULE* STANDARD-OUTPUT EOL))

;;; (DEFUN MAIN ...)

(CL:DEFUN MAIN ()
  (%%PRINT-STREAM (%NATIVE-STREAM STANDARD-OUTPUT)
   "Initializing STELLA..." EOL)
  (STARTUP-STELLA-SYSTEM)
  (%%PRINT-STREAM (%NATIVE-STREAM STANDARD-OUTPUT)
   "Initializing PowerLoom..." EOL)
  (STARTUP-LOGIC-SYSTEM)
  (%%PRINT-STREAM (%NATIVE-STREAM STANDARD-OUTPUT)
   "Initializing PowerLoom extensions..." EOL)
  (STARTUP-POWERLOOM-EXTENSIONS-SYSTEM)
  (CHANGE-MODULE "PL-USER")
  (POWERLOOM))

(CL:DEFUN STARTUP-EXTENSIONS ()
  (CL:LET*
   ((*MODULE* (GET-STELLA-MODULE "/PLX" (> *STARTUP-TIME-PHASE* 1)))
    (*CONTEXT* *MODULE*))
   (CL:DECLARE (CL:SPECIAL *MODULE* *CONTEXT*))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 2)
    (CL:SETQ KWD-EXTENSIONS-DOCUMENTATION
     (INTERN-RIGID-SYMBOL-WRT-MODULE "DOCUMENTATION" NULL 2))
    (CL:SETQ SYM-EXTENSIONS-PLX-STARTUP-EXTENSIONS
     (INTERN-RIGID-SYMBOL-WRT-MODULE "STARTUP-EXTENSIONS" NULL 0))
    (CL:SETQ SYM-EXTENSIONS-STELLA-METHOD-STARTUP-CLASSNAME
     (INTERN-RIGID-SYMBOL-WRT-MODULE "METHOD-STARTUP-CLASSNAME"
      (GET-STELLA-MODULE "/STELLA" CL:T) 0)))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 6) (FINALIZE-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 7)
    (DEFINE-FUNCTION-OBJECT "MAIN" "(DEFUN MAIN () :PUBLIC? TRUE)"
     (CL:FUNCTION MAIN) NULL)
    (DEFINE-FUNCTION-OBJECT "STARTUP-EXTENSIONS"
     "(DEFUN STARTUP-EXTENSIONS () :PUBLIC? TRUE)"
     (CL:FUNCTION STARTUP-EXTENSIONS) NULL)
    (CL:LET*
     ((FUNCTION
       (LOOKUP-FUNCTION SYM-EXTENSIONS-PLX-STARTUP-EXTENSIONS)))
     (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS FUNCTION)
      SYM-EXTENSIONS-STELLA-METHOD-STARTUP-CLASSNAME
      (WRAP-STRING "_StartupExtensions") NULL-STRING-WRAPPER)))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 8) (FINALIZE-SLOTS)
    (CLEANUP-UNFINALIZED-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 9)
    (%IN-MODULE (COPY-CONS-TREE (WRAP-STRING "PLX"))))))
